--
--쐬      :bae, joongjin
--쐬      :2006/03/27 () 11:54:25
--ΏDBMS    :Oracle 10g
--

-- 
-- TABLE: CUSTOMERS
--

DROP TABLE CUSTOMERS;

CREATE TABLE CUSTOMERS (
       CUST_ID         NUMBER(10)    NOT NULL,
       CUST_NAME       VARCHAR(100)  NOT NULL,
       PHONE           VARCHAR(100)  NOT NULL,
       FAX             VARCHAR(100)  ,
       ZIP             VARCHAR(100)  NOT NULL,
       ADDRESS         VARCHAR(100)  NOT NULL,
       CONTACT_PERSON  VARCHAR(100)  NOT NULL
);

ALTER TABLE CUSTOMERS ADD 
    CONSTRAINT CUSTOMERS_PK1 PRIMARY KEY (CUST_ID)
;



DROP SEQUENCE CUST_ID_SEQ;

CREATE SEQUENCE CUST_ID_SEQ
    INCREMENT BY 1
    START WITH 21
    MAXVALUE 2147483647
    MINVALUE 1
    NOCYCLE 
    NOCACHE
    ORDER ;




DROP TABLE PRODUCTS;

CREATE TABLE PRODUCTS (
       PROD_ID        VARCHAR(10)   NOT NULL,
       PROD_NAME      VARCHAR(100)  NOT NULL,
       UNIT_PRICE     VARCHAR(30)   NOT NULL
);

ALTER TABLE PRODUCTS ADD 
    CONSTRAINT PRODUCTS_PK1 PRIMARY KEY (PROD_ID)
;



DROP TABLE PRODUCT_ORDER;

CREATE TABLE PRODUCT_ORDER (
       ORDR_ID        VARCHAR(10)   NOT NULL,
       ORDR_DATE      TIMESTAMP     NOT NULL,
       CUST_ID        VARCHAR(10)   NOT NULL
);

ALTER TABLE PRODUCT_ORDER ADD 
    CONSTRAINT PRODUCT_ORDER_PK1 PRIMARY KEY (ORDR_ID)
;


DROP TABLE PRODUCT_ORDER_DETAILS;

CREATE TABLE PRODUCT_ORDER_DETAILS (
       ORDR_ID        VARCHAR(10)   NOT NULL,
       DETL_ID        VARCHAR(10)   NOT NULL,
       PROD_ID        VARCHAR(10)   NOT NULL,
       QUANTITY       NUMBER(20)    NOT NULL
);

ALTER TABLE PRODUCT_ORDER_DETAILS ADD 
    CONSTRAINT PRODUCT_ORDER_DETAILS_PK1 PRIMARY KEY (ORDR_ID,DETL_ID)
;



DROP SEQUENCE ORDR_ID_SEQ;

CREATE SEQUENCE ORDR_ID_SEQ
    INCREMENT BY 1
    START WITH 1
    MAXVALUE 2147483647
    MINVALUE 1
    NOCYCLE 
    NOCACHE
    ORDER ;


DROP TABLE ZIP_CODE;

CREATE TABLE ZIP_CODE (
       GROUP_CODE               VARCHAR(10)  NOT NULL,
       OLD_ZIP_CODE             VARCHAR(5)   NOT NULL,
       ZIP_CODE                 VARCHAR(7)   NOT NULL,
       ADMIN_DIVISIONS_KANA     VARCHAR(400)  NOT NULL,
       MUNICIPAL_DISTRICT_KANA  VARCHAR(400)  NOT NULL,
       TOWN_REGION_KANA         VARCHAR(400)  NOT NULL,
       ADMIN_DIVISIONS          VARCHAR(200)  NOT NULL,
       MUNICIPAL_DISTRICT       VARCHAR(200)  NOT NULL,
       TOWN_REGION              VARCHAR(200)  NOT NULL,
       TOWN_REGION_FLAG1        VARCHAR(1)   NOT NULL,
       TOWN_REGION_FLAG2        VARCHAR(1)   NOT NULL,
       TOWN_REGION_FLAG3        VARCHAR(1)   NOT NULL,
       TOWN_REGION_FLAG4        VARCHAR(1)   NOT NULL,
       UPDATE_FLAG              VARCHAR(1)   NOT NULL,
       CHANGE_FLAG              VARCHAR(1)   NOT NULL
);

ALTER TABLE ZIP_CODE ADD 
    CONSTRAINT ZIP_CODE_PK1 PRIMARY KEY (GROUP_CODE,ZIP_CODE)
;


COMMIT;
